<template lang="pug">
mixin HeaderSortIcon
  i.mr-2.mt-1.header-icon.fa&attributes(attributes)

BaseAnimationGroup(:appear='true').row
  .col-12.py-3.justify-content-center.d-flex(key='noDns' v-if='$butils.isEmpty(dns)')
    span.alert.alert-secondary Please select an experiment area...
  template(v-else)
    .col-12(key='hvInfo')
      BaseCard.x-hv.w-100(title='High Voltage Status').highlightOnFocus
        template(v-slot='card')
          li(key="boards").x-hv-boards
            BaseCollapsible(title='Show Boards Information')
              template(v-slot:default='c')
                .col-12(v-if='c.isExpanded')
                  BaseModalLoader(:isLoading="loading")
                  table.table.table-sm.table-hover.x-table-crates
                    thead
                      tr.table-head
                        th(scope='col') Crate
                        th(scope='col') Acq Stamp
                        th(scope='col') Cycle Stamp
                        th(scope='col') Cycle Name
                        th(scope='col') Model
                        th(scope='col') Firmware
                        th(scope='col') Serial
                        th(scope='col') Description
                    tbody
                      template(v-for="crate in boardInfo")
                        tr
                          td {{ crate.name }}
                          td
                            span(v-if="crate.acqStamp > 0" :title="crate.acqStamp + ' μs'")
                              | {{ NsToMs(crate.acqStamp) | b-moment("yyyy-MM-dd HH:mm:ss ZZ") }}
                          td
                            span(v-if="crate.cycleStamp > 0" :title="crate.cycleStamp + ' μs'")
                              | {{ NsToMs(crate.cycleStamp) | b-moment("yyyy-MM-dd HH:mm:ss ZZ") }}
                          td {{ crate.cycleName }}
                          td {{ crate.model }}
                          td {{ crate.firmware }}
                          td {{ crate.serial }}
                          td
                            pre {{ crate.description }}

          li(key="filters").x-hv-filters
            .row.my-1.d-flex.justify-content-center
              .col-auto.mt-1
                .btn-group(role='group' aria-label='filters').shadow-sm.border.rounded
                  button.btn(type='button' @click="setAllFilter()"
                    :class="!errorOnlyFilter && !activeOnlyFilter ? 'btn-dark' : 'text-muted'") All
                  button.btn(type='button' @click="toggleErrorFilter()"
                    :class="errorOnlyFilter ? 'btn-danger' : 'text-muted'") Error Only
                  button.btn(type='button' @click="toggleActiveFilter()"
                    :class="activeOnlyFilter ? 'btn-info' : 'text-muted'") Active Only
              .col-auto.mt-1
                .input-group
                  .input-group-prepend
                    span#regexp-filter.input-group-text Filter
                  input.form-control(v-model="regExpFilter" type='text' aria-describedby='regexp-filter')
                  .input-group-append
                    button.btn.btn-outline-secondary(type='button' @click="regExpFilter = null") Clear

          li(key="hvs").x-hv-channels
            //- Spinner while data is loading
            BaseModalLoader(:isLoading="loading")
            table.table.table-sm.table-hover.x-table-channels
              thead
                tr.table-head
                  th.clickable(scope='col' @click="setSorting('name')") Crate:Channel
                    +HeaderSortIcon()(:class="getSortingClass('name')")
                  th.clickable(scope='col' @click="setSorting('channelName')") Name
                    +HeaderSortIcon()(:class="getSortingClass('channelName')")
                  th.clickable(scope='col' @click="setSorting('caenErrorCode')") Error
                    +HeaderSortIcon()(:class="getSortingClass('caenErrorCode')")
                  th(scope='col') Status
                  th(scope='col' v-if='isScreenXL') AcqStamp
                  th.clickable(scope='col' @click="setSorting('i0set')") I0Set (mA)
                    +HeaderSortIcon()(:class="getSortingClass('i0set')")
                  th.clickable(scope='col' @click="setSorting('v0set')") V0Set (V)
                    +HeaderSortIcon()(:class="getSortingClass('v0set')")
                  th.clickable(scope='col' @click="setSorting('imon')") IMon (mA)
                    +HeaderSortIcon()(:class="getSortingClass('imon')")
                  th.clickable(scope='col' @click="setSorting('vmon')") VMon (V)
                    +HeaderSortIcon()(:class="getSortingClass('vmon')")
                  th.clickable(scope='col' @click="setSorting('pw')") PW
                    +HeaderSortIcon()(:class="getSortingClass('pw')")
                  th.clickable(scope='col' @click="setSorting('rdwn')") RDWn (V/s)
                    +HeaderSortIcon()(:class="getSortingClass('rdwn')")
                  th.clickable(scope='col' @click="setSorting('rup')") RUp (V/s)
                    +HeaderSortIcon()(:class="getSortingClass('rup')")
                  th.clickable(scope='col' @click="setSorting('svmax')") SVMax (V)
                    +HeaderSortIcon()(:class="getSortingClass('svmax')")
                  th.clickable(scope='col' @click="setSorting('trip')") Trip [s]
                    +HeaderSortIcon()(:class="getSortingClass('trip')")
              tbody
                tr(v-for="channel in hvs" :key="`${channel.name}:${channel.index}`")
                  td {{ channel.name }}:{{ channel.index }}
                  td {{ channel.channelName }}
                  td
                    pre.text-danger(v-if="channel.caenErrorCode !== 0") [E{{ channel.caenErrorCode }}] {{ channel.caenErrorMessage }}
                  td
                    pre {{ getStatusFromBitfield(channel.channelStatusBitfield) }}
                  td(v-if='isScreenXL')
                    span(v-if="channel.chanInfo && channel.chanInfo.acqStamp > 0" :title="channel.chanInfo.acqStamp + ' μs'")
                      span(v-if="isToday(NsToMs(channel.chanInfo.acqStamp))") {{ NsToMs(channel.chanInfo.acqStamp)| b-moment("HH:mm:ss") }}
                      span(v-else) {{ NsToMs(channel.chanInfo.acqStamp) | b-moment("yyyy-MM-dd HH:mm:ss ZZ") }}
                  td {{ channel.i0set | b-bigNumber }}
                    span(v-if='isScreenLG').text-muted.ml-1 ({{ channel.i0set_min | b-bigNumber }} - {{ channel.i0set_max | b-bigNumber }})
                  td {{ channel.v0set }}
                    span(v-if='isScreenLG').text-muted.ml-1 ({{ channel.v0set_min }} - {{ channel.v0set_max }})
                  td {{ channel.imon | b-bigNumber }}
                  td {{ channel.vmon | b-bigNumber }}
                  td(v-if='isScreenLG') {{ getPW(channel.pw) }}
                  td(v-if='isScreenLG') {{ channel.rdwn }}
                    span.text-muted.ml-1 ({{ channel.rdwn_min }} - {{ channel.rdwn_max }})
                  td(v-if='isScreenLG') {{ channel.rup }}
                    span.text-muted.ml-1 ({{ channel.rup_min }} - {{ channel.rup_max }})
                  td(v-if='isScreenLG') {{ channel.svmax }}
                    span.text-muted.ml-1 ({{ channel.svmax_min }} - {{ channel.svmax_max }})
                  td(v-if='isScreenLG') {{ channel.trip }}
                    span.text-muted.ml-1 ({{ channel.trip_min }} - {{ channel.trip_max }})
</template>

<script>

export { default } from './HighVoltage.vue.js';

</script>

<style lang='scss'>
.x-hv {
  .table-head > th {
    border: 1px solid #dee2e6 !important;
  }

  .table {
    td, th {
      vertical-align: middle;
      text-align: center;
      font-size: 0.9rem;
    }
    td pre {
      text-align: center;
      vertical-align: middle;
      white-space: pre-wrap;
      margin-bottom: 0;
    }
    td span.text-muted {
      font-size: 0.8rem;
    }
  }

  .header-icon {
    float: right;
    margin-right: 0.5rem !important;
    margin-top: 0.25rem !important;
  }
}
</style>
